module Cbias_mem #(
    parameter DATA_WIDTH = 8,
    parameter MEM_DEPTH  = 12,
    parameter ADDR_WIDTH = $clog2(MEM_DEPTH)
)(
    input logic                  clk,
    input logic [ADDR_WIDTH-1:0] addr_a,
    output logic [DATA_WIDTH-1:0] data_out_a
);

logic [DATA_WIDTH-1:0] mem_array [MEM_DEPTH-1:0];


always_ff @(posedge clk) begin

    data_out_a <= mem_array[addr_a];
end

initial begin
    mem_array[0]  = 8'hD6;  // –42
    mem_array[1]  = 8'hAE;  // –82
    mem_array[2]  = 8'h54;  // +84
    mem_array[3]  = 8'hE2;  // –30
    mem_array[4]  = 8'h22;  // +34
    mem_array[5]  = 8'hDC;  // –36
    mem_array[6]  = 8'h08;  //  +8
    mem_array[7]  = 8'h3D;  // +61
    mem_array[8]  = 8'h68;  // +104
    mem_array[9]  = 8'h45;  // +69
    mem_array[10] = 8'hF1;  // –15
    mem_array[11] = 8'h89;  // –119
end


endmodule