module dense(
    input logic clock,
    input logic reset,
    input logic signed [7:0] data_in,
    input logic signed [7:0] weight,
    input logic enable,
    input logic signed [7:0] dense_bias,

    output logic signed [31:0] output_data,
    output logic dense_valid,
    output logic [10:0] count_dbg,
    output logic [3:0] times_out
);

logic signed [31:0] mult;
logic signed [31:0] sum;

logic [10:0] count;
logic [3:0] times;

assign count_dbg = count;

always_ff @(posedge clock) begin
    if (reset) begin
        mult <= 0;
        sum <= 0;

    end
    else if (count == 2029) begin
        sum <= mult;
        mult <= ($signed({{8{data_in[7]}}, data_in})) * $signed({{8{weight[7]}}, weight});
    end
    else if (enable) begin
        mult <= ($signed({{8{data_in[7]}}, data_in})) * $signed({{8{weight[7]}}, weight});
        sum <=  sum + mult;
    end 
    else begin
        mult <= 0;
    end
end

always_ff @(posedge clock) begin
    if (reset) begin
        count <= 0;
    end
    else if (count == 2029) begin
        count <= 2 ;
    end
    else if (enable) begin
        count <= count +1;
    end
end

always_ff @(posedge clock) begin
    if (reset) begin
        times <= 0;
    end
    else if (count == 2029) begin
        times <= times+1;
    end
end

assign output_data =  ((count == 2029) && (times < 10)) ? ((11*(sum+dense_bias +44)>>>15)-128) : 0;
assign dense_valid = ((count == 2029) && (times < 10)) ? 1 : 0;
assign times_out = times;



endmodule