module Dbias_mem #(
    parameter DATA_WIDTH = 8,
    parameter MEM_DEPTH  = 10,
    parameter ADDR_WIDTH = $clog2(MEM_DEPTH)
)(
    input logic                  clk,
    input logic [ADDR_WIDTH-1:0] addr_a,
    output logic [DATA_WIDTH-1:0] data_out_a
);

logic [DATA_WIDTH-1:0] mem_array [MEM_DEPTH-1:0];


always_ff @(posedge clk) begin

    data_out_a <= mem_array[addr_a];
end
initial begin
  mem_array[0] = 8'h3D;
  mem_array[1] = 8'h4B;
  mem_array[2] = 8'h8B;
  mem_array[3] = 8'hD9;
  mem_array[4] = 8'hDD;
  mem_array[5] = 8'h5F;
  mem_array[6] = 8'h82;
  mem_array[7] = 8'hC9;
  mem_array[8] = 8'h6C;
  mem_array[9] = 8'h03;
  // … continue for other entries …
end


endmodule