

module weight_mem #(
    parameter DATA_WIDTH = 8,
    parameter MEM_DEPTH  = 256,
    parameter ADDR_WIDTH = $clog2(MEM_DEPTH)
)(
    input logic                  clk,
    input logic [ADDR_WIDTH-1:0] addr_a,
    output logic [DATA_WIDTH-1:0] data_out_a
);

logic [DATA_WIDTH-1:0] mem_array [MEM_DEPTH-1:0];


always_ff @(posedge clk) begin

    data_out_a <= mem_array[addr_a];
end

initial begin
mem_array[0]   = 8'h52;
mem_array[1]   = 8'h37;
mem_array[2]   = 8'h89;
mem_array[3]   = 8'h40;
mem_array[4]   = 8'h84;
mem_array[5]   = 8'hCF;
mem_array[6]   = 8'hE6;
mem_array[7]   = 8'h81;
mem_array[8]   = 8'h4E;
mem_array[9]   = 8'h2D;
mem_array[10]  = 8'hE9;
mem_array[11]  = 8'h81;
mem_array[12]  = 8'h6D;
mem_array[13]  = 8'hE3;
mem_array[14]  = 8'hAD;
mem_array[15]  = 8'h5E;
mem_array[16]  = 8'hF5;
mem_array[17]  = 8'hB0;
mem_array[18]  = 8'h06;
mem_array[19]  = 8'h2B;
mem_array[20]  = 8'hE1;
mem_array[21]  = 8'h09;
mem_array[22]  = 8'h0E;
mem_array[23]  = 8'h63;
mem_array[24]  = 8'h46;
mem_array[25]  = 8'hF4;
mem_array[26]  = 8'h7F;
mem_array[27]  = 8'h1F;
mem_array[28]  = 8'h19;
mem_array[29]  = 8'h62;
mem_array[30]  = 8'h7F;
mem_array[31]  = 8'h1F;
mem_array[32]  = 8'hCE;
mem_array[33]  = 8'h26;
mem_array[34]  = 8'hB2;
mem_array[35]  = 8'hFB;
mem_array[36]  = 8'hFC;
mem_array[37]  = 8'h40;
mem_array[38]  = 8'h4B;
mem_array[39]  = 8'h8B;
mem_array[40]  = 8'hA9;
mem_array[41]  = 8'h1E;
mem_array[42]  = 8'h29;
mem_array[43]  = 8'hC6;
mem_array[44]  = 8'h81;
mem_array[45]  = 8'h23;
mem_array[46]  = 8'h6B;
mem_array[47]  = 8'h81;
mem_array[48]  = 8'hC5;
mem_array[49]  = 8'hF8;
mem_array[50]  = 8'h6F;
mem_array[51]  = 8'h19;
mem_array[52]  = 8'h43;
mem_array[53]  = 8'h08;
mem_array[54]  = 8'h16;
mem_array[55]  = 8'h41;
mem_array[56]  = 8'h3F;
mem_array[57]  = 8'h08;
mem_array[58]  = 8'h2B;
mem_array[59]  = 8'h2C;
mem_array[60]  = 8'h86;
mem_array[61]  = 8'h81;
mem_array[62]  = 8'hA8;
mem_array[63]  = 8'h16;
mem_array[64]  = 8'hDE;
mem_array[65]  = 8'h0D;
mem_array[66]  = 8'h4F;
mem_array[67]  = 8'h7F;
mem_array[68]  = 8'h5E;
mem_array[69]  = 8'hF2;
mem_array[70]  = 8'h34;
mem_array[71]  = 8'hE4;
mem_array[72]  = 8'hCB;
mem_array[73]  = 8'h40;
mem_array[74]  = 8'h3F;
mem_array[75]  = 8'h81;
mem_array[76]  = 8'h0D;
mem_array[77]  = 8'h42;
mem_array[78]  = 8'hB0;
mem_array[79]  = 8'hD8;
mem_array[80]  = 8'h3A;
mem_array[81]  = 8'h81;
mem_array[82]  = 8'hEE;
mem_array[83]  = 8'h39;
mem_array[84]  = 8'hDB;
mem_array[85]  = 8'h29;
mem_array[86]  = 8'h44;
mem_array[87]  = 8'h32;
mem_array[88]  = 8'h0C;
mem_array[89]  = 8'hA8;
mem_array[90]  = 8'hA1;
mem_array[91]  = 8'h81;
mem_array[92]  = 8'h8F;
mem_array[93]  = 8'h9A;
mem_array[94]  = 8'hFC;
mem_array[95]  = 8'h44;
mem_array[96]  = 8'h9A;
mem_array[97]  = 8'hE6;
mem_array[98]  = 8'h19;
mem_array[99]  = 8'h81;
mem_array[100] = 8'hA1;
mem_array[101] = 8'hF7;
mem_array[102] = 8'hBA;
mem_array[103] = 8'h2A;
mem_array[104] = 8'h28;
mem_array[105] = 8'h36;
mem_array[106] = 8'h61;
mem_array[107] = 8'h1E;
end



endmodule