#ifndef _CONTROL_H
#define _CONTROL_H

#include <linux/ioctl.h>
#include <linux/types.h>

typedef unsigned int uint32_t;
typedef int int32_t;

typedef struct {
  int32_t dense_data [10];
  uint32_t image_data;
  uint32_t dense_done_f;
} control_arg_t;

#define CONTROL_MAGIC 'q'

/* ioctls and their arguments */
#define CONTROL_WRITE_IMAGE          _IOW(CONTROL_MAGIC, 1, control_arg_t)
#define CONTROL_READ_DENSE_DONE      _IOR(CONTROL_MAGIC, 2, control_arg_t)
#define CONTROL_TRIGGER_DENSE_ADDR   _IOR(CONTROL_MAGIC, 3, control_arg_t)
#define CONTROL_READ_DENSE_DATA      _IOR(CONTROL_MAGIC, 4, control_arg_t)

#endif
